/**
 * 
 */
package de.digisalt.dsnesds.core.wizards.create.file.tileset;

import org.eclipse.wb.swt.ResourceManager;

import de.digisalt.dsnesds.core.DsnesdsConstants;
import de.digisalt.dsnesds.core.wizards.create.file.AbstractNewFileWizard;
import de.digisalt.dsnesds.core.wizards.create.file.IByteStreamInput;
import de.digisalt.dsnesds.core.wizards.create.file.MetadataObject;
import de.digisalt.dsnesds.core.wizards.create.file.NewFileWizardConfigBean;

/**
 * @author flo
 */
public class NewTilesetWizard extends AbstractNewFileWizard implements
		IByteStreamInput
{
	/**
	 * The second page where the initial content of the tileset is configured
	 */
	private NewTilesetWizardPage	newTilesetWizardPage;

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.digisalt.dsnesds.core.wizards.create.file.AbstractNewFileWizard#configure
	 * ()
	 */
	@Override
	protected NewFileWizardConfigBean configure()
	{
		NewFileWizardConfigBean config = new NewFileWizardConfigBean();
		config.setContent("Tileset");
		config.setTitleImage(ResourceManager.getPluginImageDescriptor(
				"de.digisalt.dsnesds.core.wizards", "graphics/wizards/tileset.png"));
		config.setExtension("tile");
		// TODO: add custom configuration here
		return config;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.digisalt.dsnesds.core.wizards.create.file.IByteStreamInput#getByteContent
	 * ()
	 */
	@Override
	public byte[] getByteContent()
	{
		// get encoding (number of bits per pixel
		int bpp = this.newTilesetWizardPage.getEncoding();
		// get number of tiles
		int numOfTiles = this.newTilesetWizardPage.getTotalNumberOfTiles();
		// calculate byte array size to be used
		return new byte[8 * 8 * bpp * numOfTiles];
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.digisalt.dsnesds.core.wizards.create.file.AbstractNewFileWizard#
	 * addAdditionalPages()
	 */
	@Override
	public void addAdditionalPages()
	{
		this.newTilesetWizardPage = new NewTilesetWizardPage();
		addPage(this.newTilesetWizardPage);
	}

	@Override
	protected MetadataObject getMetadata()
	{
		MetadataObject metadata = new MetadataObject(
				DsnesdsConstants.namespace_tilesetFile);
		// attach metadata from the wizard page to the file
		metadata.set(DsnesdsConstants.tileset_numberOfColumns, ""
				+ this.newTilesetWizardPage.getNumberOfColumns());
		metadata.set(DsnesdsConstants.tileset_preferredEncoding,
				this.newTilesetWizardPage.getEncodingMode());
		metadata.set(DsnesdsConstants.tileset_preferredPalette, ""
				+ this.newTilesetWizardPage.getPreferredPalette());
		return metadata;
	}

}
