package de.digisalt.dsnesds.core.preferences.pages;

import java.io.FileNotFoundException;

import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import de.digisalt.dsnesds.core.Activator;
import de.digisalt.dsnesds.core.util.GraphicsFactory;

/**
 * @author flo
 * 
 *         The first (and atm only) preferences page for DSNESDS
 */
public class DsnesdsGeneralPage extends FieldEditorPreferencePage implements
		IWorkbenchPreferencePage
{
	// TODO: see
	// http://www.eclipse.org/articles/Article-Field-Editors/field_editors.html
	
	/**
	 * the standard constructor
	 */
	public DsnesdsGeneralPage()
	{
		super(FieldEditorPreferencePage.GRID);
	}
	
	/**
	 * The id of this page for reference in plugin.xml
	 */
	public static String id = "de.digisalt.dsnesds.core.preferences.pages.page1";
	
	@Override
	public void init(final IWorkbench workbench)
	{
		setPreferenceStore(Activator.getDefault().getPreferenceStore());
		setDescription("DSNESDS IDE preferences");
		ImageDescriptor desc;
		try
		{
			desc = GraphicsFactory.getIconAsImageDescriptor("dsnesds.png",
					GraphicsFactory.ICONSIZE_16x16);
			setImageDescriptor(desc);
		} catch (FileNotFoundException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	@Override
	protected void createFieldEditors()
	{
		FileFieldEditor asmPath = new FileFieldEditor("ASMPATH",
				"&Assembler executable:", true, getFieldEditorParent());
		FileFieldEditor linkPath = new FileFieldEditor("LINKPATH",
				"&Linker executable:", true, getFieldEditorParent());
		FileFieldEditor emuPath = new FileFieldEditor("EMUPATH",
				"&Emulator executable:", true, getFieldEditorParent());
		addField(asmPath);
		addField(linkPath);
		addField(emuPath);
		// SpacerFieldEditor spacer1 = new SpacerFieldEditor(
		// getFieldEditorParent());
		// addField(spacer1);
		// addField(new DirectoryFieldEditor("PATH", "&Directory preference:",
		// getFieldEditorParent()));
		// addField(new BooleanFieldEditor("BOOLEAN_VALUE",
		// "&An example of a boolean preference", getFieldEditorParent()));
		//
		// addField(new RadioGroupFieldEditor("CHOICE",
		// "An example of a multiple-choice preference", 1,
		// new String[][] { { "&Choice 1", "choice1" },
		// { "C&hoice 2", "choice2" } }, getFieldEditorParent()));
		// addField(new StringFieldEditor("MySTRING1", "A &text bla preference:",
		// getFieldEditorParent()));
		// addField(new StringFieldEditor("MySTRING2", "A &text preference:",
		// getFieldEditorParent()));
	}
	
}
