/**
 * 
 */
package de.digisalt.dsnesds.digui;

import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;

/**
 * @author flo
 */
public class BackgroundImageComposite extends DigUiComposite
{
	/**
	 * this is the image to be painted into one of the corners of this composites
	 */
	private Image	img	= null;

	/**
	 * @param bgImage
	 *          the background image to use
	 * @param parent
	 *          the parent composite to put this one into
	 * @param style
	 *          the SWT style modifiers
	 */
	public BackgroundImageComposite(final Image bgImage, final Composite parent,
			final int style)
	{
		super(parent, style);
		this.img = bgImage;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.digisalt.dsnesds.digui.DigUiComposite#drawContent(org.eclipse.swt.events
	 * .PaintEvent, int, int)
	 */
	@Override
	public void drawContent(final PaintEvent e, final GC gc, final int width,
			final int height)
	{
		int imgHeight = this.img.getBounds().height;
		int imgWidth = this.img.getBounds().width;

		gc.drawImage(this.img, width - imgWidth, height - imgHeight);
	}

}
