/**
 * 
 */
package de.digisalt.dsnesds.digui;

import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.widgets.Composite;

/**
 * @author flo
 */
public class ColorSpectrumBrowser extends DigUiComposite
{

	private enum Status
	{
		DEC, STAY, INC
	}

	int	offsetLeft	= 1;
	int	offsetTop		= -3;
	int	colorWidth	= 2;
	int	colorHeight	= 3;

	int	selXs				= (this.colorWidth) + this.offsetLeft;
	int	selYs				= (this.colorHeight) + this.offsetTop;

	/**
	 * @param parent
	 * @param style
	 */
	public ColorSpectrumBrowser(final Composite parent, final int style)
	{
		super(parent, style);
		// TODO Auto-generated constructor stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.digisalt.dsnesds.digui.DigUiComposite#drawContent(org.eclipse.swt.events
	 * .PaintEvent)
	 */
	@Override
	public void drawContent(final PaintEvent e, final GC gc, final int width,
			final int height)
	{
		this.colorHeight = (int) Math.floor(height / 63);
		this.colorWidth = (int) Math.floor(width / 188);

		this.selXs = (this.colorWidth) + this.offsetLeft;
		this.selYs = (this.colorHeight) + this.offsetTop;

		// color spectrum chooser
		int cRed = 31;
		int cGreen = 0;
		int cBlue = 0;

		boolean stop = false;

		Status redStatus = Status.STAY;
		Status greenStatus = Status.INC;
		Status blueStatus = Status.STAY;

		int currentCol = 0;
		@SuppressWarnings("unused")
		int currentRow = 0;

		while (!stop)
		{
			// 31 0 0 --> 31 31 0
			if (redStatus == Status.STAY && greenStatus == Status.INC
					&& blueStatus == Status.STAY)
			{
				for (int i = 0; i < 32; i++)
				{
					gc.setBackground(getBaseColorPlusX(i, cRed, cGreen, cBlue));
					currentRow = i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) - (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
					gc.setBackground(getBaseColorPlusX(-i, cRed, cGreen, cBlue));
					currentRow = -i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) + (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
				}
				if (cGreen != 31)
				{
					currentCol++;
					cGreen++;
				}
				else
				{
					// set status for next part
					redStatus = Status.DEC;
					greenStatus = Status.STAY;
					// stop= true;
				}
			}
			// 31 31 0 --> 0 31 0
			else if (redStatus == Status.DEC && greenStatus == Status.STAY
					&& blueStatus == Status.STAY)
			{
				for (int i = 0; i < 32; i++)
				{
					gc.setBackground(getBaseColorPlusX(i, cRed, cGreen, cBlue));
					currentRow = i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) - (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
					gc.setBackground(getBaseColorPlusX(-i, cRed, cGreen, cBlue));
					currentRow = -i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) + (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
				}
				if (cRed != 0)
				{
					currentCol++;
					cRed--;
				}
				else
				{
					// set status for next part
					redStatus = Status.STAY;
					blueStatus = Status.INC;
					// stop= true;
				}
			}
			// 0 31 0 --> 0 31 31
			else if (redStatus == Status.STAY && greenStatus == Status.STAY
					&& blueStatus == Status.INC)
			{
				for (int i = 0; i < 32; i++)
				{
					gc.setBackground(getBaseColorPlusX(i, cRed, cGreen, cBlue));
					currentRow = i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) - (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
					gc.setBackground(getBaseColorPlusX(-i, cRed, cGreen, cBlue));
					currentRow = -i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) + (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
				}
				if (cBlue != 31)
				{
					currentCol++;
					cBlue++;
				}
				else
				{
					// set status for next part
					greenStatus = Status.DEC;
					blueStatus = Status.STAY;
					// stop= true;
				}
			}
			// 0 31 31 --> 0 0 31
			else if (redStatus == Status.STAY && greenStatus == Status.DEC
					&& blueStatus == Status.STAY)
			{
				for (int i = 0; i < 32; i++)
				{
					gc.setBackground(getBaseColorPlusX(i, cRed, cGreen, cBlue));
					currentRow = i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) - (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
					gc.setBackground(getBaseColorPlusX(-i, cRed, cGreen, cBlue));
					currentRow = -i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) + (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
				}
				if (cGreen != 0)
				{
					currentCol++;
					cGreen--;
				}
				else
				{
					// set status for next part
					redStatus = Status.INC;
					greenStatus = Status.STAY;
					// stop= true;
				}
			}
			// 0 0 31 --> 31 0 31
			else if (redStatus == Status.INC && greenStatus == Status.STAY
					&& blueStatus == Status.STAY)
			{
				for (int i = 0; i < 32; i++)
				{
					gc.setBackground(getBaseColorPlusX(i, cRed, cGreen, cBlue));
					currentRow = i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) - (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
					gc.setBackground(getBaseColorPlusX(-i, cRed, cGreen, cBlue));
					currentRow = -i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) + (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
				}
				if (cRed != 31)
				{
					currentCol++;
					cRed++;
				}
				else
				{
					// set status for next part
					redStatus = Status.STAY;
					blueStatus = Status.DEC;
					// stop= true;
				}
			}
			// 31 0 31 --> 31 0 0
			else if (redStatus == Status.STAY && greenStatus == Status.STAY
					&& blueStatus == Status.DEC)
			{
				for (int i = 0; i < 32; i++)
				{
					gc.setBackground(getBaseColorPlusX(i, cRed, cGreen, cBlue));
					currentRow = i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) - (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
					gc.setBackground(getBaseColorPlusX(-i, cRed, cGreen, cBlue));
					currentRow = -i;
					gc.fillRectangle(
							this.offsetLeft + currentCol * this.colorWidth,
							this.offsetTop + (32 * this.colorHeight) + (i * this.colorHeight),
							this.colorWidth, this.colorHeight);
				}
				if (cBlue != 0)
				{
					currentCol++;
					cBlue--;
				}
				else
				{
					// set status for next part
					stop = true;
				}
			}
		}
		// rahmen zeichnen
		gc.setForeground(createColor(0, 0, 0));
		gc.drawRectangle(this.offsetLeft - 1, this.offsetTop + this.colorHeight, 6
				* 32 * this.colorWidth - this.colorWidth * 5 + 1, 2 * 32
				* this.colorHeight - this.colorHeight);

		// ausgewaehlte farbe markieren
		gc.drawRectangle(this.selXs, this.selYs, this.colorWidth - 1,
				this.colorHeight - 1);

	}

	private Color getBaseColorPlusX(int i, int red, int green, int blue)
	{
		if (i > 31)
		{
			i = 31;
		}
		if (i < -31)
		{
			i = -31;
		}
		red = (red + i);
		green = (green + i);
		blue = (blue + i);
		if (red < 0)
		{
			red = 0;
		}
		if (green < 0)
		{
			green = 0;
		}
		if (blue < 0)
		{
			blue = 0;
		}
		if (red > 31)
		{
			red = 31;
		}
		if (green > 31)
		{
			green = 31;
		}
		if (blue > 31)
		{
			blue = 31;
		}
		return createColor((red * 8) % 255, (green * 8) % 255, (blue * 8) % 255);
	}

}
