/**
 * 
 */
package de.digisalt.dsnesds.editors.paletteedit;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.editor.FormEditor;
import org.eclipse.ui.forms.editor.FormPage;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import de.digisalt.dsnesds.digui.PalettePanel;

/**
 * @author flo
 */
public class PaletteEditorFormPage extends FormPage
{

	/**
	 * Create the form page.
	 * 
	 * @param id
	 * @param title
	 */
	public PaletteEditorFormPage(final String id, final String title)
	{
		super(id, title);
	}

	/**
	 * Create the form page.
	 * 
	 * @param editor
	 * @param id
	 * @param title
	 * @wbp.parser.constructor
	 * @wbp.eval.method.parameter id "Some id"
	 * @wbp.eval.method.parameter title "Some title"
	 */
	public PaletteEditorFormPage(final FormEditor editor, final String id,
			final String title)
	{
		super(editor, id, title);
	}

	/**
	 * Create contents of the form.
	 * 
	 * @param managedForm
	 */
	@Override
	protected void createFormContent(final IManagedForm managedForm)
	{
		FormToolkit toolkit = managedForm.getToolkit();
		ScrolledForm form = managedForm.getForm();
		form.setText(getTitle());
		Composite body = form.getBody();
		toolkit.decorateFormHeading(form.getForm());
		toolkit.paintBordersFor(body);
		managedForm.getForm().getBody().setLayout(new GridLayout(1, false));

		SashForm sashForm = new SashForm(managedForm.getForm().getBody(),
				SWT.VERTICAL);
		sashForm.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		managedForm.getToolkit().adapt(sashForm);
		managedForm.getToolkit().paintBordersFor(sashForm);

		Section sctnColorPalette = managedForm.getToolkit().createSection(sashForm,
				Section.TITLE_BAR);
		managedForm.getToolkit().paintBordersFor(sctnColorPalette);
		sctnColorPalette.setText("Color Palette");
		sctnColorPalette.setExpanded(true);

		SashForm sashForm_1 = new SashForm(sctnColorPalette, SWT.NONE);
		managedForm.getToolkit().adapt(sashForm_1);
		managedForm.getToolkit().paintBordersFor(sashForm_1);
		sctnColorPalette.setClient(sashForm_1);

		Composite composite = managedForm.getToolkit().createComposite(sashForm_1,
				SWT.NONE);
		managedForm.getToolkit().paintBordersFor(composite);
		composite.setLayout(new GridLayout(1, false));

		PalettePanel palettePanel = new PalettePanel(composite, SWT.NONE);
		GridData gd_palettePanel = new GridData(SWT.FILL, SWT.FILL, true, false, 1,
				1);
		gd_palettePanel.heightHint = 101;
		palettePanel.setLayoutData(gd_palettePanel);
		managedForm.getToolkit().paintBordersFor(palettePanel);

		Group grpPaletteMetadata = new Group(composite, SWT.NONE);
		grpPaletteMetadata.setLayout(new GridLayout(2, false));
		grpPaletteMetadata.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				true, 1, 1));
		grpPaletteMetadata.setText("Palette Metadata");
		managedForm.getToolkit().adapt(grpPaletteMetadata);
		managedForm.getToolkit().paintBordersFor(grpPaletteMetadata);

		Label lblPaletteName = managedForm.getToolkit().createLabel(
				grpPaletteMetadata, "Palette name:", SWT.NONE);

		Label lblPalettename = managedForm.getToolkit().createLabel(
				grpPaletteMetadata, "", SWT.NONE);
		lblPalettename.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false, 1, 1));

		Label lblNumberOfColors = managedForm.getToolkit().createLabel(
				grpPaletteMetadata, "Number of colors:", SWT.NONE);

		Label lblNumberofcolors = managedForm.getToolkit().createLabel(
				grpPaletteMetadata, "", SWT.NONE);
		lblNumberofcolors.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false, 1, 1));

		Section sctnSelectedColor = managedForm.getToolkit().createSection(
				sashForm_1, Section.TITLE_BAR);
		managedForm.getToolkit().paintBordersFor(sctnSelectedColor);
		sctnSelectedColor.setText("Selected Color");

		Composite composite_1 = managedForm.getToolkit().createComposite(
				sctnSelectedColor, SWT.NONE);
		managedForm.getToolkit().paintBordersFor(composite_1);
		sctnSelectedColor.setClient(composite_1);
		sashForm_1.setWeights(new int[]
		{ 1, 1 });

		Section sctnColorConfiguration = managedForm.getToolkit().createSection(
				sashForm, Section.TITLE_BAR);
		managedForm.getToolkit().paintBordersFor(sctnColorConfiguration);
		sctnColorConfiguration.setText("Color Configuration");
		sctnColorConfiguration.setExpanded(true);

		SashForm sashForm_2 = new SashForm(sctnColorConfiguration, SWT.NONE);
		managedForm.getToolkit().adapt(sashForm_2);
		managedForm.getToolkit().paintBordersFor(sashForm_2);
		sctnColorConfiguration.setClient(sashForm_2);

		Section sctnAbsoluteValues = managedForm.getToolkit().createSection(
				sashForm_2, Section.TITLE_BAR);
		managedForm.getToolkit().paintBordersFor(sctnAbsoluteValues);
		sctnAbsoluteValues.setText("Absolute Values");
		sctnAbsoluteValues.setExpanded(true);

		Section sctnColorPicker = managedForm.getToolkit().createSection(
				sashForm_2, Section.TITLE_BAR);
		managedForm.getToolkit().paintBordersFor(sctnColorPicker);
		sctnColorPicker.setText("Color Picker");
		sctnColorPicker.setExpanded(true);
		sashForm_2.setWeights(new int[]
		{ 1, 1 });
		sashForm.setWeights(new int[]
		{ 1, 1 });
	}
}
