package de.digisalt.dsnesds.editors.projectmeta;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.edit.ui.util.EditUIUtil;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.forms.editor.FormEditor;

import de.digisalt.dsnesds.editors.projectmeta.model.ProjectMetaModel;
import de.digisalt.dsnesds.editors.projectmeta.model.ProjectMetaModelFactory;
import de.digisalt.dsnesds.editors.projectmeta.pages.ProjectMetaFormPage;

/**
 * @author flo
 * 
 *         The baseclass for DSNESDSs project metadata editor. It is a
 *         Formeditor and could be extended to have multiple pages in the
 *         future.
 */
public class ProjectMetaEditor extends FormEditor
{
	
	private ProjectMetaModel model;
	/**
	 * The editor ID so it can be associated with the extensionpoint
	 */
	public static String id = "de.digisalt.dsnesds.editors.projectmeta.ProjectMetaEditor";
	
	@Override
	protected void addPages()
	{
		
		// create the new model from the IFile input
		this.model = ProjectMetaModelFactory.createModel(getEditorInput());
		
		ProjectMetaFormPage page1 = new ProjectMetaFormPage(this,
				"Project Metadata", "Metadata", this.model);
		try
		{
			int index = addPage(page1);
			setPageText(index, "Project Metadata");
		} catch (PartInitException e)
		{
			// TODO: Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	/**
	   * This is the method called to load a resource into the editing domain's resource set based on the editor's input.
	   * <!-- begin-user-doc -->
	   * <!-- end-user-doc -->
	   * @generated
	   */
	  public void createModel()
	  {
	    URI resourceURI = EditUIUtil.getURI(getEditorInput());
	    Exception exception = null;
	    Resource resource = null;
	    try
	    {
	      // Load the resource through the editing domain.
	      //
	      resource = editingDomain.getResourceSet().getResource(resourceURI, true);
	    }
	    catch (Exception e)
	    {
	      exception = e;
	      resource = editingDomain.getResourceSet().getResource(resourceURI, false);
	    }

	    Diagnostic diagnostic = analyzeResourceProblems(resource, exception);
	    if (diagnostic.getSeverity() != Diagnostic.OK)
	    {
	      resourceToDiagnosticMap.put(resource,  analyzeResourceProblems(resource, exception));
	    }
	    editingDomain.getResourceSet().eAdapters().add(problemIndicationAdapter);
	  }
	
	@Override
	public void doSave(final IProgressMonitor monitor)
	{
		// TODO: Auto-generated method stub
		
	}
	
	@Override
	public void doSaveAs()
	{
		// TODO: Auto-generated method stub
		
	}
	
	@Override
	public boolean isSaveAsAllowed()
	{
		// TODO: Auto-generated method stub
		return false;
	}
	
}
