/**
 * 
 */
package de.digisalt.dsnesds.editors.projectmeta.model;

import java.util.HashMap;
import java.util.Vector;

/**
 * @author flo
 * 
 *         a class holding potential valid values for DSNESDS project constants
 */
public class PotentialValues
{
	/**
	 * a vector of potential rom timing values
	 */
	@SuppressWarnings(
	{ "serial", "unused" })
	public static final Vector<String> timingVector = new Vector<String>()
	{
		{
			add("FASTROM");
			add("SLOWROM");
		}
	};
	
	/**
	 * an array of potential adressing values
	 */
	@SuppressWarnings(
	{ "serial", "unused" })
	public static final Vector<String> adressingVector = new Vector<String>()
	{
		{
			add("LOROM");
			add("HIROM");
		}
	};
	
	/**
	 * a hashmap assigning byte values to the selectable strings
	 */
	@SuppressWarnings(
	{ "unused", "serial" })
	public static final HashMap<String, String> carttypeHashmap = new HashMap<String, String>()
	{
		{
			put("00", "ROM");
			put("01", "ROM + RAM");
			put("02", "ROM + SRAM");
			put("03", "ROM + DSP");
			put("04", "ROM + RAM + DSP");
			put("05", "ROM + SRAM + DSP");
			put("13", "ROM + SuperFX");
			put("13", "ROM + RAM + SuperFX");
			put("15", "ROM + SRAM + SuperFX");
			put("35", "ROM + SRAM + SA-1");
		}
	};
	
	/**
	 * a hashmap of potential romsizes to be used
	 */
	@SuppressWarnings(
	{ "serial", "unused" })
	public static final HashMap<String, String> romsizeHashmap = new HashMap<String, String>()
	{
		{
			put("08", "2 Megabits");
			put("09", "4 Megabits");
			put("0A", "8 Megabits");
			put("0B", "16 Megabits");
			put("0C", "32 Megabits");
		}
	};
	
	/**
	 * a hashmap of potential ramsizes to be used
	 */
	@SuppressWarnings(
	{ "serial", "unused" })
	public static final HashMap<String, String> ramsizesHashmap = new HashMap<String, String>()
	{
		{
			put("00", "0 Kilobits");
			put("01", "16 Kilobits");
			put("02", "32 Kilobits");
			put("03", "64 Kilobits");
		}
	};
	
	/**
	 * a hashmap of all countrycodes supported
	 */
	@SuppressWarnings(
	{ "unused", "serial" })
	public static final HashMap<String, String> countrycodeHashmap = new HashMap<String, String>()
	{
		{
			put("00", "Japan");
			put("01", "USA/Canada");
			put("02", "Asia/Oceania/Europe");
			put("03", "Sweden");
			put("04", "Finland");
			put("05", "Denmark");
			put("06", "France");
			put("07", "Netherlands");
			put("08", "Spain");
			put("09", "Germany/Austria/Switzerland");
			put("0A", "Italy");
			put("0B", "China/Hong Kong");
			put("0C", "Indonesia");
			put("0D", "South Korea");
		}
	};
	/**
	 * a hashmap of potential licensee names to be used
	 */
	@SuppressWarnings(
	{ "serial" })
	public static final HashMap<String, String> licenseeHashmap = new HashMap<String, String>()
	{
		{
			put("50", "Absolute Entertainment");
			put("51", "Acclaim");
			put("39", "Accolade Europe Inc.");
			put("52", "Activision");
			put("02", "Ajinomoto");
			put("53", "American Sammy");
			put("5f", "American Softworks Corp.");
			put("3b", "Arcade Zone");
			put("b1", "ASCII");
			put("d4", "Ask Kodansha");
			put("e8", "Asmik");
			put("e7", "Athena");
			put("eb", "Atlus");
			put("19", "B-AI");
			put("10", "Banalex");
			put("b2", "BanDai America");
			put("d9", "Banpresto");
			put("f3", "Beam Software");
			put("93", "BEC");
			put("4d", "Black Pearl");
			put("8b", "Bullet-Proof Software");
			put("08", "Capcom");
			put("31", "Carrozzeria");
			put("8e", "Character Soft");
			put("04", "Chris Gray Enterprises Inc.");
			put("91", "Chun Software");
			put("15", "COBRA Team");
			put("0B", "Coconuts");
			put("2a", "Culture Brain");
			put("c5", "Data East");
			put("88", "DATAM-Polystar");
			put("32", "Dynamic");
			put("27", "Electro Brain");
			put("13", "Electronic Arts");
			put("6e", "Elite");
			put("3c", "Empire Software");
			put("26", "Enix");
			put("e5", "Epoch");
			put("06", "Falcom");
			put("63", "FCI");
			put("16", "Field");
			put("1E", "Forum");
			put("19", "Game Village");
			put("54", "GameTek");
			put("12", "Gremlin Graphics");
			put("b6", "Halken");
			put("35", "Hect");
			put("55", "Hi Tech Expressions");
			put("db", "Hiro");
			put("a1", "Hori");
			put("09", "HOT-B");
			put("18", "Hudson Soft");
			put("de", "Human Entertainment");
			put("8f", "I'Max");
			put("bd", "Imagesoft");
			put("9c", "Imagineer");
			put("70", "Infogrames");
			put("2e", "INTEC Inc.");
			put("71", "Interplay");
			put("2b", "Irem Japan");
			put("0A", "Jaleco");
			put("aa", "JVC");
			put("a5", "K. Amusement");
			put("97", "Kaneco");
			put("28", "Kemco");
			put("ea", "King A Wave");
			put("17", "KOEI");
			put("74", "Konami");
			put("20", "KSS");
			put("6b", "Laser Beam");
			put("44", "LifeFitness Exertainment");
			put("56", "LJN Toys");
			put("3d", "Loriciel");
			put("83", "Lozc");
			put("72", "LucasArts");
			put("34", "Magifact");
			put("4d", "Malibu Games");
			put("14", "Masaya");
			put("62", "Maxis");
			put("0F", "Mebio Software");
			put("cd", "Meldac KAZe");
			put("23", "Micro World");
			put("0D", "Micronet");
			put("7c", "Microprose");
			put("5a", "Mindscape");
			put("80", "Misawa");
			put("82", "Namco Ltd.");
			put("e9", "Natsume");
			put("d6", "Naxat");
			put("dd", "NCS");
			put("c4", "NHK");
			put("9a", "Nichibutsu");
			put("01", "Nintendo");
			put("67", "Ocean");
			put("1E", "Open System");
			put("63", "Origin");
			put("99", "Pack in Video");
			put("2c", "Pal Soft");
			put("73", "Parker Brothers");
			put("ce", "Pony Canyon");
			put("22", "POW");
			put("ee", "Psygnosis Ltd.");
			put("d2", "Quest");
			put("0C", "Rage Software");
			put("4b", "Raya Systems");
			put("4c", "Renovation Products");
			put("df", "Ringler Studios");
			put("5b", "Romstar Inc.");
			put("96", "S'Pal");
			put("4b", "Sculptured Software");
			put("40", "Seika Corp.");
			put("29", "Seta Co. Ltd.");
			put("10", "SHOUEi System");
			put("d3", "Sigma");
			put("d1", "Sofel");
			put("ec", "Sony");
			put("cf", "Sotsu Agency");
			put("47", "Spectrum Holobyte");
			put("c3", "Squaresoft");
			put("11", "Starfish");
			put("75", "STORM");
			put("21", "Sunsoft");
			put("46", "System 3");
			put("2f", "System Sacom Corp.");
			put("e4", "T&E Software");
			put("c0", "Taito");
			put("90", "Takara");
			put("f4", "Tec Magik");
			put("0E", "Technos");
			put("1C", "Tecmo");
			put("81", "Teichio");
			put("78", "THQ Software");
			put("60", "Titus");
			put("ac", "Toei Animation");
			put("ad", "Toho");
			put("8c", "Tokai Engineering");
			put("86", "Tokuma Shoten Intermedia");
			put("da", "Tomy");
			put("c6", "Tonkin House");
			put("bc", "Toshiba EMI System Vision");
			put("5d", "Tradewest");
			put("7a", "Triffix Entertainment");
			put("87", "Tsukuda Original");
			put("4f", "U.S. Gold");
			put("41", "UBI Soft");
			put("95", "Varie");
			put("30", "Viacom New Media");
			put("92", "Video System");
			put("1F", "Virgin Interactive Entertainment");
			put("2d", "Visit Co. Ltd.");
			put("a0", "Wolf Team");
			put("1A", "Yanoman");
			put("05", "Zamuse");
			put("03", "Zoom");
		}
	};
}
