package de.digisalt.dsnesds.editors.projectmeta.model;

/**
 * @author flo
 * 
 *         This class consists all data used by the project metadata editor
 */
public class ProjectMetaModel
{
	/**
	 * the games longname (should be not longer than 20 characters)
	 */
	private String gameTitle = "Some nice game";
	/**
	 * the games shortname (should not be longer than 4 characters)
	 */
	private String gameShortname = "game";
	/**
	 * the timing value to be used
	 */
	private String timing = "FASTROM";
	/**
	 * the adressing type to be used
	 */
	private String addressing = "LOROM*";
	/**
	 * the cartridge configuration type to be used
	 */
	private String cartridgeType = "ROM + SRAM";
	/**
	 * the romsize to be used
	 */
	private String romSize = "32 Megabits";
	
	/**
	 * the ramsize to be used
	 */
	private String ramSize = "64 Kilobits";
	/**
	 * the countrycode of the game
	 */
	private String countryCode = "Japan";
	/**
	 * the licensee to be set
	 */
	private String licensee = "Nintendo";
	/**
	 * the videoformat to be used
	 */
	private String videoFormat = "NTSC";
	/**
	 * an integer (should be between 0 and 255) indicating the game version
	 */
	private int version = 0;
	
	/**
	 * @return the current game shortname (not longer than 4 characters)
	 */
	public String getGameShortname()
	{
		return this.gameShortname;
	}
	
	/**
	 * @param gameShortname
	 *          the new game shortname to be set (not longer than 4 characters)
	 */
	public void setGameShortname(final String gameShortname)
	{
		this.gameShortname = gameShortname;
	}
	
	/**
	 * @return the timing value currently set
	 */
	public String getTiming()
	{
		return this.timing;
	}
	
	/**
	 * @param timing
	 *          the timing value to be set
	 */
	public void setTiming(final String timing)
	{
		this.timing = timing;
	}
	
	/**
	 * @return the adressing value currently set
	 */
	public String getAddressing()
	{
		return this.addressing;
	}
	
	/**
	 * @param adressing
	 *          the adressing value to be set
	 */
	public void setAddressing(final String adressing)
	{
		this.addressing = adressing;
	}
	
	/**
	 * @return the cartridge type set
	 */
	public String getCartridgeType()
	{
		return this.cartridgeType;
	}
	
	/**
	 * @param cartridgeType
	 *          the cartridge type to be set
	 */
	public void setCartridgeType(final String cartridgeType)
	{
		this.cartridgeType = cartridgeType;
	}
	
	/**
	 * @return the rom size used
	 */
	public String getRomSize()
	{
		return this.romSize;
	}
	
	/**
	 * @param romSize
	 *          the romsize to be used
	 */
	public void setRomSize(final String romSize)
	{
		this.romSize = romSize;
	}
	
	/**
	 * @return the ramsize used
	 */
	public String getRamSize()
	{
		return this.ramSize;
	}
	
	/**
	 * @param ramSize
	 *          the ramsize currently used
	 */
	public void setRamSize(final String ramSize)
	{
		this.ramSize = ramSize;
	}
	
	/**
	 * @return the countrycode used
	 */
	public String getCountryCode()
	{
		return this.countryCode;
	}
	
	/**
	 * @param countryCode
	 *          the countrycode to be used
	 */
	public void setCountryCode(final String countryCode)
	{
		this.countryCode = countryCode;
	}
	
	/**
	 * @return the licensee set
	 */
	public String getLicensee()
	{
		return this.licensee;
	}
	
	/**
	 * @param licensee
	 *          the licensee to be used
	 */
	public void setLicensee(final String licensee)
	{
		this.licensee = licensee;
	}
	
	/**
	 * @return the videoformat used
	 */
	public String getVideoFormat()
	{
		return this.videoFormat;
	}
	
	/**
	 * @param videoFormat
	 *          the videoformat to be used
	 */
	public void setVideoFormat(final String videoFormat)
	{
		this.videoFormat = videoFormat;
	}
	
	/**
	 * @return the game longname set (should be up to 20 characters long)
	 */
	public String getGameTitle()
	{
		return this.gameTitle;
	}
	
	/**
	 * @return the version currently set
	 */
	public int getVersion()
	{
		return this.version;
	}
	
	/**
	 * @param gameTitle
	 *          the game title to be set
	 */
	public void setGameTitle(final String gameTitle)
	{
		this.gameTitle = gameTitle;
	}
	
	/**
	 * @param version
	 *          the version to be set (0 - 255)
	 */
	public void setVersion(final int version)
	{
		this.version = version;
	}
	
}
