package de.digisalt.dsnesds.editors.projectmeta.model;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import org.eclipse.core.internal.resources.ResourceException;
import org.eclipse.core.resources.IFile;

import de.digisalt.dsnesds.core.util.DsnesdsGlobalConstants;
import de.digisalt.dsnesds.core.util.ResourceUtil;

@SuppressWarnings("restriction")
public class Loader
{
	public static Model load(IFile input) throws ResourceException,
			UnsupportedEncodingException, FileNotFoundException,
			WrongDsnesdsVersionException
	{
		BufferedReader in = ResourceUtil.createBufferedReader(input);
		String gameName = null;
		String shortName = null;
		String timing = null;
		String addressing = null;
		String carttype = null;
		String romsize = null;
		String ramsize = null;
		String country = null;
		String licensee = null;
		String video = null;
		int version = 0;
		try
		{

			int i = 0;
			while (true)
			{
				i++;
				String line = in.readLine();
				if (line == null) break;
				String[] tokens = line.split("=");
				// TODO: evaluate key at loading time... making the loader more robust
				@SuppressWarnings("unused")
				String key = tokens[0];
				String val = tokens[1];
				if (tokens.length > 2)
				{
					for (int j = 2; j < tokens.length; j++)
					{
						val += "=" + tokens[j];
					}
				}
				switch (i)
				{
				case 1:
				{
					if (!DsnesdsGlobalConstants.dsnesdsVersion.equals(val))
						throw new WrongDsnesdsVersionException();
					break;
				}
				case 2:
				{
					gameName = val;
					break;
				}
				case 3:
				{
					shortName = val;
					break;
				}
				case 4:
				{
					timing = val;
					break;
				}
				case 5:
				{
					addressing = val;
					break;
				}
				case 6:
				{
					carttype = val;
					break;
				}
				case 7:
				{
					romsize = val;
					break;
				}
				case 8:
				{
					ramsize = val;
					break;
				}
				case 9:
				{
					country = val;
					break;
				}
				case 10:
				{
					licensee = val;
					break;
				}
				case 11:
				{
					video = val;
					break;
				}
				case 12:
				{
					version = Integer.valueOf(val);
					break;
				}
				default:
				{

					break;
				}
				}
			}
		}
		catch (IOException e)
		{
			// do nothing as the file was read successfully
		}
		return new Model(gameName, shortName, timing, addressing, carttype,
				romsize, ramsize, country, licensee, video, version);
	}
}
