package de.digisalt.dsnesds.editors.projectmeta.model;

import java.io.BufferedWriter;
import java.io.IOException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;

import de.digisalt.dsnesds.core.util.DsnesdsGlobalConstants;
import de.digisalt.dsnesds.core.util.ResourceUtil;

public class Serializer
{
	public static void save(IFile output, Model model) throws IOException,
			CoreException
	{
		String stringToWrite = "dsnesds_version="
				+ DsnesdsGlobalConstants.dsnesdsVersion + "\n";
		stringToWrite += "longname=" + model.getGameName() + "\n";
		stringToWrite += "shortname=" + model.getShortName() + "\n";
		stringToWrite += "timing=" + model.getTiming() + "\n";
		stringToWrite += "addressing=" + model.getAddressing() + "\n";
		stringToWrite += "carttype=" + model.getCarttype() + "\n";
		stringToWrite += "romsize=" + model.getRomsize() + "\n";
		stringToWrite += "ramsize=" + model.getRamsize() + "\n";
		stringToWrite += "country=" + model.getCountry() + "\n";
		stringToWrite += "licensee=" + model.getLicensee() + "\n";
		stringToWrite += "video=" + model.getVideo() + "\n";
		stringToWrite += "version=" + model.getVersion() + "\n";

		BufferedWriter out = ResourceUtil.createBufferedWriter(output);
		out.write(stringToWrite);
		out.flush();
		output.refreshLocal(0, null);
		model.modelWasSavedSuccessfully();
	}
}
