package de.digisalt.dsnesds.editors.projectmeta.validators;

import org.eclipse.core.databinding.validation.IValidator;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

import de.digisalt.dsnesds.editors.projectmeta.Activator;

/**
 * @author flo
 * 
 *         This is a validator to ensure a valid game shortname (one consisting
 *         of up to 4 letters) is present
 */
public class GameShortnameValidator implements IValidator
{
	@Override
	public IStatus validate(final Object value)
	{
		if (value == null)
		{
			return new Status(IStatus.ERROR, Activator.PLUGIN_ID,
					"Null value was provided for validation.");
		}
		if (value instanceof String)
		{
			String gameName = (String) value;
			if (gameName.equals(""))
			{
				return new Status(IStatus.INFO, Activator.PLUGIN_ID,
						"Please enter a game shortname of up to 4 characters.");
			} else if (gameName.length() > 4)
			{
				return new Status(IStatus.ERROR, Activator.PLUGIN_ID,
						"The game name mustn't be longer than 4 characters.");
			}
			return new Status(IStatus.OK, Activator.PLUGIN_ID,
					"The game shortname is ok.");
		}
		return new Status(IStatus.ERROR, Activator.PLUGIN_ID,
				"An unknown validationerror occurred.");
	}
}
